Option Explicit

Dim objReg, objWMIService, colProcesses, objProcess, objFSO, objFile, blnAnotherScriptISRunning
Dim strComputer, strKeyPath, objArgs, strProcess, process, strProcessPath, strFile, strRemoveApp
Dim arrSubKeys, subkey, strDisplayNameValue, strUninstallValue, FileList, File
Dim i, CRLF

Const HKEY_LOCAL_MACHINE = &H80000002
Const ForReading = 1, ForWriting = 2, ForAppending = 8

strProcess = "agentsvc.exe"

strComputer = "."
Set objArgs = WScript.Arguments
CRLF = Chr(13) & Chr(10)

Set objFSO = CreateObject("scripting.filesystemobject")
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

'Check to make sure the script is not already running.
Set colProcesses = objWMIService.ExecQuery _
    ("SELECT commandline FROM Win32_Process WHERE commandline LIKE '%" & wscript.scriptname & "%'")
If colProcesses.Count > 1 Then
  blnAnotherScriptISRunning=True
End If

' Check to make sure we received arguments.
  if objArgs.Count = 0 Then
    WScript.Echo "USAGE: cscript //nologo ''Cleanup IM Jobs.vbs'' ''AutoLogon Disable and Logoff''" & CRLF & _
                 "Where the application string is how it appears in 'Add or Remove Programs'." & CRLF & _
                 "You can append as many application strings as you like. Each string must be" & CRLF & _
                 "surrounded by double quotes, and a space must exist between each string."
    WScript.Quit 0
  End If

' Check to see if the process is running.
  Set colProcesses = objWMIService.ExecQuery _
  ("SELECT * FROM Win32_Process WHERE Name = '" & strProcess & "'")
  If colProcesses.Count > 0 Then

'   Get the path of the running process.
    for each process in colProcesses
      strProcessPath = Left(process.ExecutablePath, InstrRev(process.ExecutablePath, "\"))
'     wscript.echo strProcessPath
    Next
    strFile = strProcessPath & "Cleanup IM Jobs.txt"

'   Write the arguments to a text file
    For i = 0 to objArgs.Count - 1
      Call OutputToFile(objArgs(i),strFile)
    Next

'   Now exit if another copy of the script is running.
    If blnAnotherScriptISRunning = True Then
      wscript.quit
    End If

'   Otherwise, wait for the process to end.
    Set colProcesses = objWMIService.ExecNotificationQuery _
      ("Select * From __InstanceDeletionEvent " _ 
              & "Within 1 Where TargetInstance ISA 'Win32_Process'")
    Do Until i = 999
    Set objProcess = colProcesses.NextEvent
      If lcase(objProcess.TargetInstance.Name) = lcase(strProcess) Then
        Exit Do
      End If
    Loop

'   Then take action
    Call CleanAddRemovePrograms(strFile)

'   Rename the text file
    Call RenameFile(strFile, strProcessPath)

  End If

Set objReg = Nothing
set objWMIService = Nothing
Set objFSO = Nothing
Set objFile = Nothing

WScript.Quit

' This function will write the entries to a text file
Function OutputToFile(strRemoveApp,strFile)
    Set objFile = objFSO.OpenTextFile(strFile,ForAppending,True,0) 
    objFile.WriteLine strRemoveApp
    objFile.Close
End Function

' This function will read the entries from a text file and delete the coresponding keys from the registry.
Function CleanAddRemovePrograms(strFile)
' This function is used to remove unwanted "Add or Remove Programs" entries after certain
' Installation Manager jobs have been deployed.
' Note: To show up in "Add or Remove Programs", the Uninstall key must contain both a DisplayName
' and an UninstallString value. Therefore, we first search for the key that matches the
' DisplayName we want, and if the UninstallString contains aginst, the entire key is deleted.

  Set objFile = objFSO.OpenTextFile(strFile,ForReading,True,0) 
  strRemoveApp = objFile.ReadLine

  Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _ 
      strComputer & "\root\default:StdRegProv")

  strKeyPath = "Software\Microsoft\Windows\CurrentVersion\Uninstall"
  objReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, arrSubKeys
'***Uncomment the next three lines for debugging purposes only to display the contents of the array elements.
'   For i = 0 to UBound(arrSubKeys)
'     Wscript.echo "Array element " & i & " contains a value of " & arrSubKeys(i)
'   Next

  For Each subkey In arrSubKeys
    objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath + "\" + subkey,"DisplayName",strDisplayNameValue
'***Uncomment the next three lines for debugging purposes only to display the DisplayName string.
'   If strDisplayNameValue <> "" Then
'     Wscript.echo strDisplayNameValue
'   End If
    If lcase(strDisplayNameValue) = lcase(strRemoveApp) Then
    objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath + "\" + subkey,"UninstallString",strUninstallValue
      IF instr(lcase(strUninstallValue),"aginst") > 0 Then
        objReg.DeleteKey HKEY_LOCAL_MACHINE,strKeyPath + "\" + subkey
        Wscript.echo "DisplayName: " & strDisplayNameValue & ". UninstallString: " & strUninstallValue
      End If
    End If
  Next
  objFile.Close
End Function

' This subroutine will rename the file by appending the date 'yyyymmdd' and a unique number to the file name.
Sub RenameFile(strFile, strProcessPath)
   Dim sExt, sBaseName, sCreationDate, strDestFile, sDate, sFormattedDate, i, blnfileExists
    If objFSO.FileExists(strFile) Then
        sExt = objFSO.GetExtensionName(strFile)
        sBaseName = objFSO.GetBaseName(strFile)
        sDate = split(FormatDateTime(Now + 1, vbShortDate),"/")
        sFormattedDate=sDate(2) & sDate(1) & sDate(0)
	i = 1
        strDestFile = sBaseName & "_" & sFormattedDate & "_" & i & "." & sExt
	blnfileExists = objFSO.FileExists(strProcessPath & strDestFile)
        Do while blnfileExists = True
	  i = i + 1
          strDestFile = sBaseName & "_" & sFormattedDate & "_" & i & "." & sExt
	  blnfileExists = objFSO.FileExists(strProcessPath & strDestFile)
	Loop
        objFSO.MoveFile strFile, strProcessPath & strDestFile
    End If
End Sub
